import requests
import os
import sys
import multiprocessing
import urllib

pdb_ids = [l[0:4] for l in open(sys.argv[1]).readlines()]
ccp4_urls = [str("http://www.ebi.ac.uk/pdbe/coordinates/files/" + i + ".ccp4").lower() for i in pdb_ids]


def fetch_url(url):
    ccp4file = './ccp4_data/' + url[-9:-5] + '.ccp4'
    #ccp4file = url[-9:-5] + '.ccp4'
    if not os.path.isfile(ccp4file):
        try:
            print(url)
            urllib.request.urlretrieve(url, ccp4file)
        except urllib.error.HTTPError as e:
            print('HTTP error:', e.reason)
            return (url, False)
        except urllib.error.URLError as e:
            print(e.reason)
            return ('URL error:', url, False)

        #response = requests.get(url)
        #if response.status_code == 200:
        #    with open(ccp4file, 'a+') as fh:
        #        fh.write(response.text)
        #else:
        #    return (url, False)

    ccp4file = './ccp4_data/' + url[-9:-5] + '_diff.ccp4'
    #ccp4file = url[-9:-5] + '_diff.ccp4'
    url = url[:-5] + "_diff" + url[-5:]
    if not os.path.isfile(ccp4file):
        try:
            print(url)
            urllib.request.urlretrieve(url, ccp4file)
        except urllib.error.HTTPError as e:
            print('HTTP error:', e.reason)  
            return (url, False)
        except urllib.error.URLError as e:
            print(e.reason)
            return (url, False)

        #response = requests.get(url)
        #if response.status_code == 200:
        #    with open(ccp4file, 'a+') as fh:
        #        fh.write(response.text)
        #        return (url, True)
        #else:
        #    return (url, False)

workers = multiprocessing.Pool(10)
results = workers.map(fetch_url, ccp4_urls)


